<template>
    <v-container>
        <v-row>
            <v-col
            cols="12"
            >
                <v-dialog
                    ref="dialog"
                    v-model="modal"
                    :return-value.sync="date"
                    persistent
                    width="290px"
                >
                    <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                        v-model="dateFormatted"
                        label="เลือกเดือน"
                        prepend-icon="mdi-calendar"
                        
                        readonly
                        v-bind="attrs"
                        v-on="on"
                    ></v-text-field>
                    </template>
                    <v-date-picker
                    v-model="date"
                    locale="th-TH"
                    type="month"
                    scrollable
                    >
                    <v-spacer></v-spacer>
                    <v-btn
                        text
                        color="primary"
                        @click="modal = false"
                    >
                        Cancel
                    </v-btn>
                    <v-btn
                        text
                        color="primary"
                        @click="$refs.dialog.save(date); getCovidDataInMonth();"
                    >
                        OK
                    </v-btn>
                    </v-date-picker>
                </v-dialog>
            </v-col>
            <v-spacer></v-spacer>
            <v-col
             cols="12"
            >
                <apexcharts
                
                height="450"
                type="bar"
                :options="chartOptions"
                :series="series"
                ></apexcharts>
            </v-col>
        </v-row>
    </v-container>
</template>
<script>
import VueApexCharts from "vue-apexcharts"
export default {
    name:'ChartMonth',
    data: () => ({
      date: new Date().toISOString().substr(0, 7),
      modal: false,
      dateFormatted : null,
      chartOptions: {
        chart: {
          id: "basic-bar",
          animations: {
            speed: 200
          }
        },
        dataLabels: {
          enabled: false,
          offsetY: -20,
          style: {
                fontSize: '12px',
                colors: ["#304758"]
            }
        },
        plotOptions: {
          bar: {
            distributed: false,
            dataLabels: {
                  position: 'top', // top, center, bottom
                },
          },
          horizontal: false,
            
        },
        xaxis: {
          categories: []
        },
        colors: ['#EF5350'],
        title: {
              text: 'กราฟรายเดือน',
              floating: true,
              offsetY: 0,
              align: 'left',
              style: {
                color: '#444'
              }
            }
      },
      series:[]
      
    }),
    components :{
        apexcharts: VueApexCharts
    },
    
    created () {
        this.dateFormatted= this.formatDate((new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substr(0, 10))
        this.getCovidDataInMonth()
    },
    watch: {
      date (val) {
        this.dateFormatted = this.formatDate(val)
      },
    },
    methods:{
        getCovidDataInMonth(){
            const [year, month] = this.date.split('-')
            this.axios.get(`https://bb1c-2403-6200-8831-8c23-e9be-1eb7-339f-2d93.ngrok.io/api/v1/covid/new_case_per_date_in_month?month=${month}&year=${year}`).then(response =>{
                this.series =  [
                                {
                                name: "จำนวนผู้ติดเชื้อ",
                                    data: response.data.value,
                                
                                }
                            ]
                console.log(response.data)
            })
        },
        formatDate (date) {
            if (!date) return null

            const [year, month] = date.split('-')
            return `${month}/${(parseInt(year)+543)}`
        },
    }
}
</script>